var CSSUtils = function(selector) {
	if (selector) {
		if (window === this) {
			// избегаем создания переменных в window
			return new CSSUtils(selector);
		}

		this.e = document.querySelectorAll(selector);

		(this.e.length == 1) ?
				console.log("1 element selected") :
				console.log(this.e.length + " elements selected");

		return this;
	}
};

CSSUtils.prototype = {
/*
	hide: function () {
		this.e.style.display = 'none';
		return this;
	},

	show: function () {
		this.e.style.display = 'inherit';
		return this;
	},

	toggle: function () {
		if (this.e.style.display !== 'none') {
			this.e.style.display = 'none';
		} else {
			this.e.style.display = '';
		}
		return this;
	},
*/
	/** Добавляет класс */
	add: function(className) {
		var hasClassPattern = new RegExp('(\\s|^)' + className + '(\\s|$)');
		for (var i = this.e.length - 1; i >= 0; i--) {
			if (!this.e[i].className.match(hasClassPattern)) {
				// не добавляем класс, если он уже есть (чтобы не было "bold bold")
				// кроме того, избавляемся от лишних пробелов:
				this.e[i].className += (!this.e[i].className ? className : ' ' + className);
			}
		}
		return this;
	},

	/** Удаляет класс (без аргумента - все классы) */
	remove: function(className) {
		if (className) {
			var pattern = new RegExp('(\\s*|^)' + className + '(\\s*|$)');
			for (var i = this.e.length - 1; i >= 0; i--) {
				if (this.e[i].className)
					this.e[i].className = this.e[i].className.replace(pattern, '');
			}
		} else { // без аргумента или "" == убрать все классы
			for (var i = this.e.length - 1; i >= 0; i--) {
				this.e[i].className = '';
			}
		}

		return this;
	},

	/** Добавляет/удаляет класс */
	toggle: function(className) {
		var removePattern = new RegExp('(\\s|^)' + className + '(\\s|$)');
		var hasClassPattern = new RegExp('(\\s|^)' + className + '(\\s|$)');

		for (var i = this.e.length - 1; i >= 0; i--) {
			if (this.e[i].className.match(hasClassPattern)) {
				this.e[i].className = this.e[i].className.replace(removePattern, '');
			} else {
				this.e[i].className += (!this.e[i].className ? className : ' ' + className);
			}
		}

		return this;
	}
};

window.$ = CSSUtils;